require("socket")

serv = "irc.freenode.net" --should take command args
nick = "LUABOT" --same
channel = "#chat" --also same
welcomemsg = "I am a bot. Use !help for a list of commands!"--false for none
adminLoginUser = "OWNER"
adminLoginPass = "OPER PASS" 
authPass = "password"



list = {}
lineregex = "[^\r\n]+"
memo = {}
commands = {}
privCommands = {}
operators = {}

function deliver(s, content)
	s:send(content .. "\r\n\r\n")
end

function loadConfig(configfile)
	local file = io.open(configfile, "r")
	if not file then
		local file = io.open(configfile, "w")
		file:write("SERVER\nNICK\nCHANNEL\nADMINUSER\nADMINPASS\nAUTHPASSWORD\nWELCOME MESSAGE!")
		file:close()
		print("Edit the new config.txt in this directory! ")
		error()
	else
		local tmp = {}
		for v in file:lines() do
			table.insert(tmp, v)
		end

		serv = tmp[1]
		nick = tmp[2]
		channel = tmp[3]
		adminLoginUser = tmp[4]
		adminLoginPass = tmp[5]
		authPass = tmp[6]
		welcomemsg = tmp[7]
	end
end

function msg(s, channel, content)
	deliver(s, "PRIVMSG " .. channel .. " :" .. content)
end

function wait(n)
	local Current=os.time()
	local Goal=Current+n
	repeat until os.time()>=Goal
end

function repspace(main, first, second)
	-- start with 0 --> first instance to replace
	local relapsed = string.sub(main, 1, string.find(main, first) -1 ) 
	
	local temp = string.sub(main, string.find(main, first) + #first)
	relapsed = relapsed .. second .. temp
	
	while string.find(relapsed, first) do
		temp = string.sub(relapsed, string.find(relapsed, first) + #first)
		relapsed = string.sub(relapsed, 1, string.find(relapsed, first) -1 )
		
		relapsed = relapsed .. second .. temp
	end
	
	return relapsed
end

function getpage(url)
	local http = require("socket.http")
	local page = {}
	local page, status = http.request(url)
	return page
end

function isOp(nick, host)
	if operators[nick] ~= nil and operators[nick] == host then
		return true
	end

	return false
end

--Adding commands. Like !command. You don't have to use a !. I didn't with the http:// one.
function addCommand(command, description, callbackFunc)
	commands[command] = {desc = description, callback = callbackFunc}
end
function addPrivCommand(command, callbackFunc)
	privCommands[command] = callbackFunc
end
--                   ----====   The Lua IRC Bot   ====----I tried to make all the descriptions fit together for looks
addCommand("!woot", "--!woot - woot.com deal of the day---", function(s, channel, lnick, line)
	local page = getpage("http://www.woot.com/")
	for line in string.gmatch(page, "[^\r\n]+") do
		if string.find(line, "<h2 class=\"fn\">") then
			local name = string.sub(line, string.find(line, "\">")+2, string.find(line, "</")-1)
			msg(s, channel, "the woot item of the day is " .. name)
		end
		if string.find(line, "<span class=\"amount\">") then
			local price = string.sub(line, (string.find(line, "\"amount")+9), (string.find(line, "</span")-1))
			msg(s, channel, "this item is selling for: " .. price)
		end
	end
end)--                ----====   The Lua IRC Bot   ====----
addCommand("!memo ", "----!memo - Send a memo to users=----", function(s, channel, lnick, line)
	local nick = string.sub(line, string.find(line, "!memo ")+6, #line)
	if string.find(nick, " ") then
		nick = string.sub(nick, 1, string.find(nick, " ")-1)
		local message = string.sub(line, string.find(line, nick)+#nick+1, #line)
		local found = false
		for key, val in pairs(memo) do
			if key == nick then found = true end
		end
		if not found then memo[nick] = "<" .. lnick .. "> " .. message end
	end
end)--               ----====   The Lua IRC Bot   ====----
addCommand("!help", "---!help - Show a list of commands---", function(s,channel,lnick,line)
	msg(s, channel, "----=============================----")
	msg(s, channel, "----====   The Lua IRC Bot   ====----")
	for k, v in pairs(commands) do
		if commands[k].desc then
			msg(s, channel, commands[k].desc)
		end
	end
	msg(s, channel, "----=============================----")
end)
addCommand( "!die", false, function(a,b,lnick) -- Hidden from !help. IDK why, don't want people trying to abuse it
	if lnick == "LordOfGears2" then
		msg(a, b, "NoooOOOOOoooO!")
		os.exit()
	end
end)
addCommand("http://", false, function(s, channel, lnick, line) --Example of a command not using !
	local request = string.sub(line, string.find(line, "http://"), #line)
	if string.find(request, " ") then 
		request = string.sub(request, 1, (string.find(request, " ")-1))
	end
		
	local page = getpage(request)
	if page == nil then
	  msg(s, channel, "I'm being a responsible bot and reporting an error!")
	else
		for lin in string.gmatch(page, lineregex) do
			if string.find(lin, "<title>") then
				if #lin < string.find(lin, "<title>")+8 then
				else
					if lin:find("<title>") and lin:find("</title>") then
						local title = string.sub(lin, (string.find(lin, "<title>")+7), (string.find(lin, "</title")-1))
						msg(s, channel, title)
					end
				end
			end
		end
	end
end)
addPrivCommand("!auth", function(s, lnick, line)
	print(lnick.." tried to auth")
	if string.find(line, authPass) then
		operators[#operators+1] = lnick
		print(" and was successful")
	end
end)
--Takes the line and checks for commands, other things etc. The memo system is called here.
function process(s, channel, lnick, line) 
	for key, val in pairs(memo) do
		if key == lnick then
			msg(s, channel, lnick .. ": " .. val)
			memo[lnick] = nil 
		end
	end
	for k,v in pairs(commands) do
		if string.find(line, k) then
			commands[k].callback(s, channel, lnick, line)
		end
	end
end

function privProcess(s, lnick, line, host)--Private message processing
	print("PRIVATE MESSAGE:  "..lnick.."   "..line)
	for k,v in pairs(privCommands) do
		if string.find(line, k) then
			privCommands[k](s, lnick, line)
		end
	end
end

function connect(server, n, chan, user, pass)
	print("[+] setting up socket to " .. server)
	local s = socket.tcp()
	s:connect(socket.dns.toip(server), 6667)

	print("[+] trying nick", n)

	s:send("USER "..n.."  "..n.." "..n.." "..":"..n.."\r\n\r\n")
	s:send("NICK " .. n.."\r\n\r\n")
	print("[+] joining", chan)
	s:send("JOIN "..chan.."\r\n\r\n")

	if welcomemsg then msg(s, chan, tostring(welcomemsg)) end
	s:send("OPER "..user.." "..pass.."\r\n\r\n")

	return s
end

--Load config before connecting
loadConfig("config.txt")
--Connecting!
s = connect(serv, nick, channel, adminLoginUser, adminLoginPass);

--Main bit. Takes control os everything and calls things like process
local line = nil
while true do
	--Just get the one line
		receive = s:receive('*l')
	
	--Make sure we ping back
	if string.find(receive, "PING :") then
		s:send("PONG :" .. string.sub(receive, (string.find(receive, "PING :") + 6)) .. "\r\n\r\n")
		print("[+] sent server pong")
	else
		--Is it a chat message?
		if string.find(receive, "PRIVMSG") then
			if receive:find(channel .. " :") then line = string.sub(receive, (string.find(receive, channel .. " :") + (#channel) + 2)) end
			if receive:find(nick .. " :") then line = string.sub(receive, (string.find(receive, nick .. " :") + (#nick) + 2)) end
			if receive:find(":") and receive:find("!") then lnick = string.sub(receive, (string.find(receive, ":")+1), (string.find(receive, "!")-1)) end
			if lnick then host = string.sub(receive, string.find(receive, "@")+1, -1*(string.find(receive, " PRIVMSG"))) end
			print(host.." <- host")
			if line and string.find(receive, "PRIVMSG "..nick) then --Private messages are handled serperately. For things like !auth
				privProcess(s, lnick, line)
			elseif line then
				process(s, channel, lnick, line)
			end
		end		
	end
	print(receive)
end
